# -*- coding: utf-8 -*-

"""Test Logos

Utilisation :
    créer les variables d'environnement: (indiquer les valeurs
    pour le serveur ScoDoc que vous voulez interroger)

    export SCODOC_URL="https://scodoc.xxx.net/"
    export SCODOC_USER="xxx"
    export SCODOC_PASSWD="xxx"
    export CHECK_CERTIFICATE=0 # ou 1 si serveur de production avec certif SSL valide

    (on peut aussi placer ces valeurs dans un fichier .env du répertoire tests/api).

    Lancer :
        pytest tests/api/test_api_formations.py
"""

import requests

from tests.api.setup_test_api import SCODOC_URL, CHECK_CERTIFICATE, HEADERS

# formations
def test_formations():
    r = requests.get(
        SCODOC_URL + "/ScoDoc/api/formations",
        headers=HEADERS,
        verify=CHECK_CERTIFICATE,
    )
    assert r.status_code == 200


# formations_by_id
def test_formations_by_id():
    r = requests.get(
        SCODOC_URL + "/ScoDoc/api/formations/1",
        headers=HEADERS,
        verify=CHECK_CERTIFICATE,
    )
    assert r.status_code == 200


# formation_export_by_formation_id
def test_formation_export_by_formation_id():
    r = requests.get(
        SCODOC_URL + "/ScoDoc/api/formations/formation_export/1",
        headers=HEADERS,
        verify=CHECK_CERTIFICATE,
    )
    assert r.status_code == 200


# formsemestre_apo
def test_formsemestre_apo():
    r = requests.get(
        SCODOC_URL + "/ScoDoc/api/formations/apo/<string:etape_apo>",
        headers=HEADERS,
        verify=CHECK_CERTIFICATE,
    )
    assert r.status_code == 200


# moduleimpls
def test_moduleimpls():
    r = requests.get(
        SCODOC_URL + "/ScoDoc/api/formations/moduleimpl/<int:moduleimpl_id>",
        headers=HEADERS,
        verify=CHECK_CERTIFICATE,
    )
    assert r.status_code == 200


# moduleimpls_sem
def test_moduleimpls_sem():
    r = requests.get(
        SCODOC_URL
        + "/ScoDoc/api/formations/moduleimpl/formsemestre/1/liste",
        headers=HEADERS,
        verify=CHECK_CERTIFICATE,
    )
    assert r.status_code == 200
